<?php

/**
 * THIS FILE IS PUBLIC DOMAIN STUFF. GIVEN FOR FREE FOR LEARNING PURPOSES.
 * USE IT ON YOUR OWN RISK. 
 * WE ACCEPT NO LIABILITY ON HOW IT BEHAVES.
 */
class be_data {

    public $id = 0;
    public $timestamp = 0;
    public $content = "";

}

class da_data {

    /**
     * 
     * @param type $entry
     * @return type
     * @throws Exception
     */
    public static function Insert($entry) {
        $sqlCommand = "INSERT INTO data (content)"
                . " VALUES (?)";

        $paramTypeSpec = "s";
        $mysqli = da_helper::mysqli_connect();

        if ($mysqli->connect_errno) {
            $msg = "Failed to connect to MySQL: (" . $mysqli->connect_errno . ") " . $mysqli->connect_error;
            throw new Exception($msg, $mysqli->connect_errno);
        }

        if (!($stmt = $mysqli->prepare($sqlCommand))) {
            $msg = "Prepare failed: (" . $mysqli->errno . ") " . $mysqli->error;
            throw new Exception($msg, $stmt->errno);
        }

        if (!$stmt->bind_param($paramTypeSpec, $entry->content)) {
            $msg = "Binding parameters failed: (" . $stmt->errno . ") " . $stmt->error;
            throw new Exception($msg, $stmt->errno);
        }
        if (!$stmt->execute()) {
            $msg = "Execute failed: (" . $stmt->errno . ") " . $stmt->error;
            throw new Exception($msg, $stmt->errno);
        }

        $stmt->close();

        $insertedEntryID = $mysqli->insert_id;

        //$insertedEntry = da_data::getSpecificEntry($insertedEntryID);
        return $insertedEntryID;
    }

    public static function Get($from, $to) {
        $sqlCommand = "SELECT * from data"
                . " WHERE timestamp >= ? AND timestamp <= ?";

        $paramTypeSpec = "ss";
        $mysqli = da_helper::mysqli_connect();

        if ($mysqli->connect_errno) {
            $msg = "Failed to connect to MySQL: (" . $mysqli->connect_errno . ") " . $mysqli->connect_error;
            throw new Exception($msg, $mysqli->connect_errno);
        }

        if (!($stmt = $mysqli->prepare($sqlCommand))) {
            $msg = "Prepare failed: (" . $mysqli->errno . ") " . $mysqli->error;
            throw new Exception($msg, $stmt->errno);
        }

        if (!$stmt->bind_param($paramTypeSpec, $from, $to)) {
            $msg = "Binding parameters failed: (" . $stmt->errno . ") " . $stmt->error;
            throw new Exception($msg, $stmt->errno);
        }
        if (!$stmt->execute()) {
            $msg = "Execute failed: (" . $stmt->errno . ") " . $stmt->error;
            throw new Exception($msg, $stmt->errno);
        }

        $entry = new be_data();
        $stmt->bind_result(
                $entry->id, $entry->timestamp, $entry->contenido);
        $arrayResult = [];
        while ($stmt->fetch()) {
            $arrayResult[] = json_decode(json_encode($entry));
        }

        $stmt->close();
        return $arrayResult;
    }

    public static function GetLast($records) {
        $sqlCommand = "SELECT * from data "
                . " ORDER BY id DESC "
                . " LIMIT ?";

        $paramTypeSpec = "i";
        $mysqli = da_helper::mysqli_connect();

        if ($mysqli->connect_errno) {
            $msg = "Failed to connect to MySQL: (" . $mysqli->connect_errno . ") " . $mysqli->connect_error;
            throw new Exception($msg, $mysqli->connect_errno);
        }

        if (!($stmt = $mysqli->prepare($sqlCommand))) {
            $msg = "Prepare failed: (" . $mysqli->errno . ") " . $mysqli->error;
            throw new Exception($msg, $stmt->errno);
        }

        if (!$stmt->bind_param($paramTypeSpec, $records)) {
            $msg = "Binding parameters failed: (" . $stmt->errno . ") " . $stmt->error;
            throw new Exception($msg, $stmt->errno);
        }
        if (!$stmt->execute()) {
            $msg = "Execute failed: (" . $stmt->errno . ") " . $stmt->error;
            throw new Exception($msg, $stmt->errno);
        }

        $entry = new be_data();
        $stmt->bind_result(
                $entry->id, $entry->timestamp, $entry->contenido);
        $arrayResult = [];
        while ($stmt->fetch()) {
            $arrayResult[] = json_decode(json_encode($entry));
        }

        $stmt->close();
        return $arrayResult;
    }

}
